#include "Test.h"
#include "Vektor.h"
#include <iostream>
using namespace std;

/** Es wird ein Vektor erzeugt und mit dem Wert 81
gefllt. Anschlieend wird geprft, ob auch jedes
Element den Wert 81 hat.
*/
bool testInit() {
   Vektor<double> v(4);
   const double wert=81;
   v.InitWert(wert);
   for (int i=0; i<v.GetDim(); ++i)   {
      if (v[i] != wert) {
         return false;
      }
   }
   return true;
}

/** Es wird ein Vektor erzeugt und mit dem Wert 81
gefllt. Anschlieend wird geprft, ob auch jedes
Element den Wert 81 hat.
*/
bool testInitInt() {
   Vektor<int> v(4);
   const int wert=81;
   v.InitWert(wert);
   for (int i=0; i<v.GetDim(); ++i)   {
      if (v[i] != wert) {
         return false;
      }
   }
   return true;
}




/** Es wird ein Vektor erzeugt und mit dem Wert 81
gefllt. Anschlieend wird geprft, ob auch jedes
Element den Wert 81 hat.
*/
bool testOutputDouble() {
   Vektor<double> v(4);
   const double wert = 81.34;
   v.InitWert(wert);
   cout << "Vektor v ist\n  " << v << endl;
   return true;
}

/** Es werden zwei Vektoren erzeugt und mit 
den Werten 81 und -10 belegt. Nach Aufruf
von Add sollte der ergebnis-Vektor den
Wert 71 enthalten. 
*/
bool testPlus() {
   Vektor<int> v1(4);
   const int wert1=81;
   v1.InitWert(wert1);

   Vektor<int> v2(4);
   const int wert2= -10;
   v2.InitWert(wert2);

   Vektor<int> result(5);
   result = v1 + v2;

   for (int i=0; i<result.GetDim(); ++i)   {
      if (result[i] != (wert1+wert2)) {
         return false;
      }
   }
   return true;
}
/** Zwei Vektoren der Gre 3 und 30 werden angelegt.
Beide werden 22 initialisiert. Es wird geprft, 
ob diese Werte auch drin sind.
*/
bool testDynVektor(){
   const int wert=22;

   Vektor<int> v1(3);
   v1.InitWert(wert);
   for (int i=0; i<v1.GetDim(); ++i)   {
      if (v1[i] != wert) {
         return false;
      }
   }

   Vektor<int> v2(30);
   v2.InitWert(wert);
   for (int i=0; i<v2.GetDim(); ++i)   {
      if (v2[i] != wert) {
         return false;
      }
   }
   return true;
}

/** Ein Vektor mit 4 Elementen wird angelegt.
Anschlieend wird Resize fr ihn mit 400 Elementen ausgefhrt.
Alle werden werden mit 88 belegt. Wenn jedes Vektorelement
nun die 88 enthlt ist der Test erfolgreich.
Anschlieend wird nochmals Resize mit 13 Elementen aufgerufen.
*/
bool testResize() {

   Vektor<int> v1(4);
   const int wert=88;
   v1.InitWert(wert);
   int newDim = 400;
   v1.Resize(newDim);
   v1.InitWert(wert);
   if (v1.GetDim() != newDim) {
      return false;
   }
   for (int i=0; i<v1.GetDim(); ++i)   {
      if (v1[i] != wert) {
         return false;
      }
   }

   newDim = 400;
   v1.Resize(newDim);
   v1.InitWert(wert);
   if (v1.GetDim() != newDim) {
      return false;
   }
   for (int i=0; i<v1.GetDim(); ++i)   {
      if (v1[i] != wert) {
         return false;
      }
   }
   return true;
}

