

#include <iostream>
#include <iomanip> // wegen setw
#include <cassert> // wegen assert
using namespace std;
 
/** Fr dim int-Werte wird auf
dem Heap Platz geschaffen, die anschieend
mit 0 initialisiert werden.
*/
template <typename T>
Vektor<T>::Vektor(int dim) {
   daten = new T[dim];
   dimension = dim;
   InitWert(0);
}

/** Sofern dimension > 0 ist, wird der Heap-
Speicher von v freigegeben.
*/
template <typename TYP>
Vektor<TYP>::~Vektor() {
   if (dimension > 0) {
      delete[] daten;
      daten=NULL;
      dimension=0;
   }
}

template <typename T>
Vektor<T>::Vektor(const Vektor& v2) {
   dimension = v2.dimension;
   daten = new T [dimension];
   for (int i=0; i<dimension; ++i) {
      daten[i] = v2.daten[i];
   }
}


template <typename T>
Vektor<T>& Vektor<T>::operator=(const Vektor& v2){
   if (this != &v2)    {
      delete [] daten;
      dimension=v2.dimension;
      daten = new T[dimension];
      for (int i=0; i<dimension; ++i) {
         daten[i] = v2.daten[i];
      }
   }
   return *this;
}

template <typename T>
void Vektor<T>::InitWert(const T& wert) {
   for (int i=0; i<dimension; ++i){
      daten[i] = wert;
   }
}


template <typename U>
Vektor<U> operator+(const Vektor<U>& v1, const Vektor<U>& v2) {
   assert(v1.dimension == v2.dimension);
   Vektor<U> erg(v1.dimension);
   for (int i=0; i<v1.dimension; ++i){
      erg.daten[i] = v1.daten[i] + v2.daten[i];
   }
   return erg;
}

template <typename U>
ostream& operator<<(ostream& str, const Vektor<U>& v) {
   for (int i=0; i<v.dimension; ++i){
      cout << setw(4) << v.daten[i] << " ";
   }
   return str;
}

/** ndert die Vektorgre auf newDim, wobei die alten
Daten gelscht werden.
*/
template <typename T>
void Vektor<T>::Resize(int newDim)  {
   delete [] daten;
   daten = new T [newDim];
   dimension = newDim;
   InitWert(0);
}


